% CSTR model
function xa_dot=cstr_linear(t,xa,xa_in)

% Mole fractions (1 = xa + xb)
xb = 1-xa;

% Parameters:
% Volumetric Flowrate (m^3/sec)
q = 1;
% Volume of CSTR (m^3)
V = 1;
% Reaction kinetics
k1 = 0.5;
k2 = 0.2;

% Steady state conditions (point for linearization)
xa_in_ss = 0.5;
xa_ss = 0.5610;
xb_ss = 1-xa_ss;

% Compute d(xa)/dt for linearized system
xa_dot = q/V * (xa_in-xa_in_ss) + ...
    (-q/V - 2*k1*xa_ss + k2*xb_ss) * (xa-xa_ss) + ...
    (k2 * xa_ss) * (xb-xb_ss);
